#include <bits/stdc++.h>
using namespace std;
long long n,m, dp [10007][10007],mat[10007][10007];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >>m;
    for (int i=1;i<=n;i++){
        for (int j=1;j<=m;j++){
           cin >> mat[i][j];
           mat[i][j]=mat[i][j]+mat[i-1][j]+mat[i][j-1]-mat[i-1][j-1];
        }
    }
    for (int i=1;i<=n;i++){
        for (int j=1;j<=m;j++){
            dp[i][j]=min(mat[i-1][j]-mat[i][j-1]+dp[i][j-1], mat[i][j-1]-mat[i-1][j-1]+dp[i-1][j]);

        }
    }
    cout << dp[n][m]<<endl;

    return 0;
}